Index: palm/trunk/SOURCE/advec_ws.f90
===================================================================
--- palm/trunk/SOURCE/advec_ws.f90	(revision 3633)
+++ palm/trunk/SOURCE/advec_ws.f90	(revision 3634)
@@ -4712,26 +5304,60 @@
              DO  k = nzb_max+1, nzt
 
-                u_comp    = u(k,j-1,i+1) + u(k,j,i+1) - gu
-                flux_r(k) = u_comp * (                                        &
+                u_comp = u(k,j-1,i+1) + u(k,j,i+1) - gu
+                flux_r = u_comp * (                                           &
                       37.0_wp * ( v(k,j,i+1) + v(k,j,i)   )                      &
                     -  8.0_wp * ( v(k,j,i+2) + v(k,j,i-1) )                      &
                     +           ( v(k,j,i+3) + v(k,j,i-2) ) ) * adv_mom_5
 
-                diss_r(k) = - ABS( u_comp ) * (                               &
+                diss_r = - ABS( u_comp ) * (                                  &
                       10.0_wp * ( v(k,j,i+1) - v(k,j,i) )                        &
                     -  5.0_wp * ( v(k,j,i+2) - v(k,j,i-1) )                      &
                     +           ( v(k,j,i+3) - v(k,j,i-2) ) ) * adv_mom_5
 
-
-                v_comp(k) = v(k,j+1,i) + v(k,j,i)
-                flux_n(k) = ( v_comp(k) - gv ) * (                            &
+#ifdef _OPENACC
+!
+!--             Recompute the left fluxes.
+                u_comp_l = u(k,j-1,i) + u(k,j,i) - gu
+                flux_l   = u_comp_l * (                                       &
+                             37.0_wp * ( v(k,j,i) + v(k,j,i-1)   )               &
+                           -  8.0_wp * ( v(k,j,i+1) + v(k,j,i-2) )               &
+                           +           ( v(k,j,i+2) + v(k,j,i-3) ) ) * adv_mom_5
+                diss_l   = - ABS( u_comp_l ) * (                              &
+                             10.0_wp * ( v(k,j,i) - v(k,j,i-1)   )               &
+                           -  5.0_wp * ( v(k,j,i+1) - v(k,j,i-2) )               &
+                           +           ( v(k,j,i+2) - v(k,j,i-3) ) ) * adv_mom_5
+#else
+                flux_l = swap_flux_x_local_v(k,j)
+                diss_l = swap_diss_x_local_v(k,j)
+#endif
+
+                v_comp = v(k,j+1,i) + v(k,j,i)
+                flux_n = ( v_comp - gv ) * (                                  &
                       37.0_wp * ( v(k,j+1,i) + v(k,j,i)   )                      &
                     -  8.0_wp * ( v(k,j+2,i) + v(k,j-1,i) )                      &
                       +         ( v(k,j+3,i) + v(k,j-2,i) ) ) * adv_mom_5
 
-                diss_n(k) = - ABS( v_comp(k) - gv ) * (                       &
+                diss_n = - ABS( v_comp - gv ) * (                             &
                       10.0_wp * ( v(k,j+1,i) - v(k,j,i)   )                      &
                     -  5.0_wp * ( v(k,j+2,i) - v(k,j-1,i) )                      &
                     +           ( v(k,j+3,i) - v(k,j-2,i) ) ) * adv_mom_5
+
+#ifdef _OPENACC
+!
+!--             Recompute the south fluxes.
+                v_comp_s = v(k,j,i) + v(k,j-1,i) - gv
+                flux_s   = v_comp_s * (                                       &
+                           37.0_wp * ( v(k,j,i) + v(k,j-1,i)   )                 &
+                         -  8.0_wp * ( v(k,j+1,i) + v(k,j-2,i) )                 &
+                         +           ( v(k,j+2,i) + v(k,j-3,i) ) ) * adv_mom_5
+                diss_s   = - ABS( v_comp_s ) * (                              &
+                           10.0_wp * ( v(k,j,i) - v(k,j-1,i)   )                 &
+                         -  5.0_wp * ( v(k,j+1,i) - v(k,j-2,i) )                 &
+                         +           ( v(k,j+2,i) - v(k,j-3,i) ) ) * adv_mom_5
+#else
+                flux_s = swap_flux_y_local_v(k)
+                diss_s = swap_diss_y_local_v(k)
+#endif
+
 !
 !--             k index has to be modified near bottom and top, else array
@@ -4745,6 +5371,6 @@
                 k_mm  = k - 2 * ibit26
 
-                w_comp    = w(k,j-1,i) + w(k,j,i)
-                flux_t(k) = w_comp * rho_air_zw(k) * (                       &
+                w_comp = w(k,j-1,i) + w(k,j,i)
+                flux_t = w_comp * rho_air_zw(k) * (                          &
                           ( 37.0_wp * ibit26 * adv_mom_5                        &
                        +     7.0_wp * ibit25 * adv_mom_3                        &
@@ -4761,5 +5387,5 @@
                                       )
 
-                diss_t(k) = - ABS( w_comp ) * rho_air_zw(k) * (              &
+                diss_t = - ABS( w_comp ) * rho_air_zw(k) * (                 &
                           ( 10.0_wp * ibit26 * adv_mom_5                        &
                        +     3.0_wp * ibit25 * adv_mom_3                        &
@@ -4780,5 +5406,5 @@
 !--             by a not sufficient reduction of divergences near topography.
                 div = ( ( u_comp + gu - ( u(k,j-1,i)   + u(k,j,i)   ) ) * ddx &
-                     +  ( v_comp(k)   - ( v(k,j,i)     + v(k,j-1,i) ) ) * ddy &
+                     +  ( v_comp      - ( v(k,j,i)     + v(k,j-1,i) ) ) * ddy &
                      +  (   w_comp                      * rho_air_zw(k) -     &
                           ( w(k-1,j-1,i) + w(k-1,j,i) ) * rho_air_zw(k-1)     &
@@ -4787,40 +5413,41 @@
  
                 tend(k,j,i) = tend(k,j,i) - (                                 &
-                       ( flux_r(k) + diss_r(k)                                &
-                     -   swap_flux_x_local_v(k,j) - swap_diss_x_local_v(k,j)  &
-                       ) * ddx                                                &
-                     + ( flux_n(k) + diss_n(k)                                &
-                     -   swap_flux_y_local_v(k) - swap_diss_y_local_v(k)      &
-                       ) * ddy                                                &
-                     + ( ( flux_t(k) + diss_t(k) )                            &
-                     -   ( flux_d    + diss_d    )                            &
-                       ) * drho_air(k) * ddzw(k)                              &
+                       ( ( flux_r + diss_r )                                  &
+                     -   ( flux_l + diss_l ) ) * ddx                          &
+                     + ( ( flux_n + diss_n )                                  &
+                     -   ( flux_s + diss_s ) ) * ddy                          &
+                     + ( ( flux_t + diss_t )                                  &
+                     -   ( flux_d + diss_d ) ) * drho_air(k) * ddzw(k)        &
                                             )  + v(k,j,i) * div
 
-                swap_flux_x_local_v(k,j) = flux_r(k)
-                swap_diss_x_local_v(k,j) = diss_r(k)
-                swap_flux_y_local_v(k)   = flux_n(k)
-                swap_diss_y_local_v(k)   = diss_n(k)
-                flux_d                   = flux_t(k)
-                diss_d                   = diss_t(k)
+#ifndef _OPENACC
+                swap_flux_x_local_v(k,j) = flux_r
+                swap_diss_x_local_v(k,j) = diss_r
+                swap_flux_y_local_v(k)   = flux_n
+                swap_diss_y_local_v(k)   = diss_n
+#endif
+                flux_d                   = flux_t
+                diss_d                   = diss_t
 
 !
 !--             Statistical Evaluation of v'v'. The factor has to be applied
 !--             for right evaluation when gallilei_trans = .T. .
+                !$ACC ATOMIC
                 sums_vs2_ws_l(k,tn) = sums_vs2_ws_l(k,tn)                      &
-                + ( flux_n(k)                                                  &
-                    * ( v_comp(k) - 2.0_wp * hom(k,1,2,0)                   )  &
-                    / ( v_comp(k) - gv + SIGN( 1.0E-20_wp, v_comp(k) - gv ) )  &
-               +   diss_n(k)                                                   &
-                    *   ABS( v_comp(k) - 2.0_wp * hom(k,1,2,0)              )  &
-                    / ( ABS( v_comp(k) - gv ) + 1.0E-20_wp                  )  &
+                + ( flux_n                                                     &
+                    * ( v_comp - 2.0_wp * hom(k,1,2,0)                   )     &
+                    / ( v_comp - gv + SIGN( 1.0E-20_wp, v_comp - gv )    )     &
+               +   diss_n                                                      &
+                    *   ABS( v_comp - 2.0_wp * hom(k,1,2,0)              )     &
+                    / ( ABS( v_comp - gv ) + 1.0E-20_wp                  )     &
                   ) *   weight_substep(intermediate_timestep_count)
 !
 !--             Statistical Evaluation of w'u'.
+                !$ACC ATOMIC
                 sums_wsvs_ws_l(k,tn) = sums_wsvs_ws_l(k,tn)                    &
-                + ( flux_t(k)                                                  &
+                + ( flux_t                                                     &
                     * ( w_comp - 2.0_wp * hom(k,1,3,0)                   )     &
                     / ( w_comp + SIGN( 1.0E-20_wp, w_comp )              )     &
-               +   diss_t(k)                                                   &
+               +   diss_t                                                      &
                     *   ABS( w_comp - 2.0_wp * hom(k,1,3,0)              )     &
                     / ( ABS( w_comp ) + 1.0E-20_wp                       )     &
@@ -4830,5 +5457,7 @@
           ENDDO
        ENDDO
+!$ACC UPDATE HOST(sums_vs2_ws_l(nzb+1,tn))
        sums_vs2_ws_l(nzb,tn) = sums_vs2_ws_l(nzb+1,tn)
+!$ACC UPDATE DEVICE(sums_vs2_ws_l(nzb,tn))
 
 
@@ -4874,7 +5503,17 @@
        REAL(wp)    ::  ibit28 !< flag indicating 3rd-order scheme along x-direction
        REAL(wp)    ::  ibit29 !< flag indicating 5th-order scheme along x-direction
+#ifdef _OPENACC
+       REAL(wp)    ::  ibit27_l !< flag indicating 1st-order scheme along x-direction
+       REAL(wp)    ::  ibit28_l !< flag indicating 3rd-order scheme along x-direction
+       REAL(wp)    ::  ibit29_l !< flag indicating 5th-order scheme along x-direction
+#endif
        REAL(wp)    ::  ibit30 !< flag indicating 1st-order scheme along y-direction
        REAL(wp)    ::  ibit31 !< flag indicating 3rd-order scheme along y-direction
        REAL(wp)    ::  ibit32 !< flag indicating 5th-order scheme along y-direction
+#ifdef _OPENACC
+       REAL(wp)    ::  ibit30_s !< flag indicating 1st-order scheme along y-direction
+       REAL(wp)    ::  ibit31_s !< flag indicating 3rd-order scheme along y-direction
+       REAL(wp)    ::  ibit32_s !< flag indicating 5th-order scheme along y-direction
+#endif
        REAL(wp)    ::  ibit33 !< flag indicating 1st-order scheme along z-direction
        REAL(wp)    ::  ibit34 !< flag indicating 3rd-order scheme along z-direction
@@ -4886,22 +5525,39 @@
        REAL(wp)    ::  gv     !< Galilei-transformation velocity along y
        REAL(wp)    ::  u_comp !< advection velocity along x
+#ifdef _OPENACC
+       REAL(wp)    ::  u_comp_l !< advection velocity along x
+#endif
        REAL(wp)    ::  v_comp !< advection velocity along y
+#ifdef _OPENACC
+       REAL(wp)    ::  v_comp_s !< advection velocity along y
+#endif
        REAL(wp)    ::  w_comp !< advection velocity along z
        
-       REAL(wp), DIMENSION(nzb:nzt)    ::  diss_t !< discretized artificial dissipation at top of the grid box
-       REAL(wp), DIMENSION(nzb:nzt)    ::  flux_t !< discretized 6th-order flux at top of the grid box
+       REAL(wp)    ::  diss_t !< discretized artificial dissipation at top of the grid box
+       REAL(wp)    ::  flux_t !< discretized 6th-order flux at top of the grid box
        
-       REAL(wp), DIMENSION(nzb+1:nzt)  ::  diss_n !< discretized artificial dissipation at northward-side of the grid box
-       REAL(wp), DIMENSION(nzb+1:nzt)  ::  diss_r !< discretized artificial dissipation at rightward-side of the grid box
-       REAL(wp), DIMENSION(nzb+1:nzt)  ::  flux_n !< discretized 6th-order flux at northward-side of the grid box
-       REAL(wp), DIMENSION(nzb+1:nzt)  ::  flux_r !< discretized 6th-order flux at rightward-side of the grid box
+       REAL(wp)    ::  diss_n !< discretized artificial dissipation at northward-side of the grid box
+       REAL(wp)    ::  diss_r !< discretized artificial dissipation at rightward-side of the grid box
+       REAL(wp)    ::  flux_n !< discretized 6th-order flux at northward-side of the grid box
+       REAL(wp)    ::  flux_r !< discretized 6th-order flux at rightward-side of the grid box
+
+       REAL(wp)    ::  diss_s !< discretized artificial dissipation at southward-side of the grid box
+       REAL(wp)    ::  flux_s !< discretized 6th-order flux at southward-side of the grid box
+#ifndef _OPENACC
        REAL(wp), DIMENSION(nzb+1:nzt)  ::  swap_diss_y_local_w !< discretized artificial dissipation at southward-side of the grid box
        REAL(wp), DIMENSION(nzb+1:nzt)  ::  swap_flux_y_local_w !< discretized 6th-order flux at southward-side of the grid box
+#endif
        
+       REAL(wp)    ::  diss_l !< discretized artificial dissipation at leftward-side of the grid box
+       REAL(wp)    ::  flux_l !< discretized 6th-order flux at leftward-side of the grid box
+#ifndef _OPENACC
        REAL(wp), DIMENSION(nzb+1:nzt,nys:nyn) ::  swap_diss_x_local_w !< discretized artificial dissipation at leftward-side of the grid box
        REAL(wp), DIMENSION(nzb+1:nzt,nys:nyn) ::  swap_flux_x_local_w !< discretized 6th-order flux at leftward-side of the grid box
+#endif
  
        gu = 2.0_wp * u_gtrans
        gv = 2.0_wp * v_gtrans
+
+#ifndef _OPENACC
 !
 !--   compute the whole left boundary of the processor domain
@@ -4962,7 +5618,26 @@
 
        ENDDO
-
+#endif
+
+       !$ACC PARALLEL LOOP COLLAPSE(2) FIRSTPRIVATE(tn, gu, gv) &
+       !$ACC PRIVATE(i, j, k, k_mm, k_pp, k_ppp) &
+       !$ACC PRIVATE(ibit27, ibit28, ibit29, ibit30, ibit31, ibit32) &
+       !$ACC PRIVATE(ibit27_l, ibit28_l, ibit29_l) &
+       !$ACC PRIVATE(ibit30_s, ibit31_s, ibit32_s) &
+       !$ACC PRIVATE(ibit33, ibit34, ibit35) &
+       !$ACC PRIVATE(flux_r, diss_r, flux_l, diss_l) &
+       !$ACC PRIVATE(flux_n, diss_n, flux_s, diss_s) &
+       !$ACC PRIVATE(flux_t, diss_t, flux_d, diss_d) &
+       !$ACC PRIVATE(div, u_comp, u_comp_l, v_comp, v_comp_s, w_comp) &
+       !$ACC PRESENT(advc_flags_1, advc_flags_2) &
+       !$ACC PRESENT(u, v, w) &
+       !$ACC PRESENT(rho_air, drho_air_zw, ddzu) &
+       !$ACC PRESENT(tend) &
+       !$ACC PRESENT(hom(nzb+1:nzb_max,1,3,0)) &
+       !$ACC PRESENT(weight_substep(intermediate_timestep_count)) &
+       !$ACC PRESENT(sums_ws2_ws_l(nzb+1:nzb_max,0))
        DO i = nxl, nxr
 
+#ifndef _OPENACC
           j = nys
           DO  k = nzb+1, nzb_max
@@ -5018,4 +5693,5 @@
 
           ENDDO
+#endif
 
           DO  j = nys, nyn
@@ -5025,10 +5701,8 @@
 !--          at the first w-level. For topography wall this is done implicitely
 !--          by advc_flags_1.
-             k         = nzb + 1
-             w_comp    = w(k,j,i) + w(k-1,j,i)
-             flux_t(0) = w_comp       * ( w(k,j,i) + w(k-1,j,i) ) * adv_mom_1
-             diss_t(0) = -ABS(w_comp) * ( w(k,j,i) - w(k-1,j,i) ) * adv_mom_1
-             flux_d    = flux_t(0)
-             diss_d    = diss_t(0)
+             k      = nzb + 1
+             w_comp = w(k,j,i) + w(k-1,j,i)
+             flux_d = w_comp       * ( w(k,j,i) + w(k-1,j,i) ) * adv_mom_1
+             diss_d = -ABS(w_comp) * ( w(k,j,i) - w(k-1,j,i) ) * adv_mom_1
 
              DO  k = nzb+1, nzb_max
@@ -5038,6 +5712,6 @@
                 ibit27 = REAL( IBITS(advc_flags_1(k,j,i),27,1), KIND = wp )
 
-                u_comp    = u(k+1,j,i+1) + u(k,j,i+1) - gu
-                flux_r(k) = u_comp * (                                       &
+                u_comp = u(k+1,j,i+1) + u(k,j,i+1) - gu
+                flux_r = u_comp * (                                          &
                           ( 37.0_wp * ibit29 * adv_mom_5                        &
                        +     7.0_wp * ibit28 * adv_mom_3                        &
@@ -5054,5 +5728,5 @@
                                      )
 
-                diss_r(k) = - ABS( u_comp ) * (                              &
+                diss_r = - ABS( u_comp ) * (                                 &
                           ( 10.0_wp * ibit29 * adv_mom_5                        &
                        +     3.0_wp * ibit28 * adv_mom_3                        &
@@ -5069,10 +5743,53 @@
                                               )
 
+#ifdef _OPENACC
+!
+!--             Recompute the left fluxes.
+                ibit29_l = REAL( IBITS(advc_flags_1(k,j,i-1),29,1), KIND = wp )
+                ibit28_l = REAL( IBITS(advc_flags_1(k,j,i-1),28,1), KIND = wp )
+                ibit27_l = REAL( IBITS(advc_flags_1(k,j,i-1),27,1), KIND = wp )
+
+                u_comp_l = u(k+1,j,i) + u(k,j,i) - gu
+                flux_l   = u_comp_l * (                                      &
+                                      ( 37.0_wp * ibit29_l * adv_mom_5          &
+                                   +     7.0_wp * ibit28_l * adv_mom_3          &
+                                   +              ibit27_l * adv_mom_1          &
+                                      ) *                                    &
+                                     ( w(k,j,i)   + w(k,j,i-1) )             &
+                               -      (  8.0_wp * ibit29_l * adv_mom_5          &
+                                   +              ibit28_l * adv_mom_3          &
+                                      ) *                                    &
+                                     ( w(k,j,i+1) + w(k,j,i-2) )             &
+                               +      (           ibit29_l * adv_mom_5          &
+                                      ) *                                    &
+                                     ( w(k,j,i+2) + w(k,j,i-3) )             &
+                                                 )
+
+                diss_l   = - ABS( u_comp_l ) * (                             &
+                                        ( 10.0_wp * ibit29_l * adv_mom_5        &
+                                     +     3.0_wp * ibit28_l * adv_mom_3        &
+                                     +              ibit27_l * adv_mom_1        &
+                                        ) *                                  &
+                                     ( w(k,j,i)   - w(k,j,i-1) )             &
+                                 -      (  5.0_wp * ibit29_l * adv_mom_5        &
+                                     +              ibit28_l * adv_mom_3        &
+                                        ) *                                  &
+                                     ( w(k,j,i+1) - w(k,j,i-2) )             &
+                                 +      (           ibit29_l * adv_mom_5        &
+                                        ) *                                  &
+                                     ( w(k,j,i+2) - w(k,j,i-3) )             &
+                                                            )
+#else
+                flux_l = swap_flux_x_local_w(k,j)
+                diss_l = swap_diss_x_local_w(k,j)
+#endif
+
+
                 ibit32 = REAL( IBITS(advc_flags_2(k,j,i),0,1),  KIND = wp )
                 ibit31 = REAL( IBITS(advc_flags_1(k,j,i),31,1), KIND = wp )
                 ibit30 = REAL( IBITS(advc_flags_1(k,j,i),30,1), KIND = wp )
 
-                v_comp    = v(k+1,j+1,i) + v(k,j+1,i) - gv
-                flux_n(k) = v_comp * (                                       &
+                v_comp = v(k+1,j+1,i) + v(k,j+1,i) - gv
+                flux_n = v_comp * (                                          &
                           ( 37.0_wp * ibit32 * adv_mom_5                        &
                        +     7.0_wp * ibit31 * adv_mom_3                        &
@@ -5089,5 +5806,5 @@
                                      )
 
-                diss_n(k) = - ABS( v_comp ) * (                              &
+                diss_n = - ABS( v_comp ) * (                                 &
                           ( 10.0_wp * ibit32 * adv_mom_5                        &
                        +     3.0_wp * ibit31 * adv_mom_3                        &
@@ -5103,4 +5820,47 @@
                                  ( w(k,j+3,i) - w(k,j-2,i) )                 &
                                               )
+
+#ifdef _OPENACC
+!
+!--             Recompute the south fluxes.
+                ibit32_s = REAL( IBITS(advc_flags_2(k,j-1,i),0,1),  KIND = wp )
+                ibit31_s = REAL( IBITS(advc_flags_1(k,j-1,i),31,1), KIND = wp )
+                ibit30_s = REAL( IBITS(advc_flags_1(k,j-1,i),30,1), KIND = wp )
+
+                v_comp_s = v(k+1,j,i) + v(k,j,i) - gv
+                flux_s   = v_comp_s * (                                      &
+                                    ( 37.0_wp * ibit32_s * adv_mom_5            &
+                                 +     7.0_wp * ibit31_s * adv_mom_3            &
+                                 +              ibit30_s * adv_mom_1            &
+                                    ) *                                      &
+                                     ( w(k,j,i)   + w(k,j-1,i) )             &
+                             -      (  8.0_wp * ibit32_s * adv_mom_5            &
+                                 +              ibit31_s * adv_mom_3            &
+                                    ) *                                      &
+                                     ( w(k,j+1,i) + w(k,j-2,i) )             &
+                             +      (           ibit32_s * adv_mom_5            &
+                                    ) *                                      &
+                                     ( w(k,j+2,i) + w(k,j-3,i) )             &
+                                               )
+
+                diss_s   = - ABS( v_comp_s ) * (                             &
+                                    ( 10.0_wp * ibit32_s * adv_mom_5            &
+                                 +     3.0_wp * ibit31_s * adv_mom_3            &
+                                 +              ibit30_s * adv_mom_1            &
+                                    ) *                                      &
+                                     ( w(k,j,i)   - w(k,j-1,i) )             &
+                             -      (  5.0_wp * ibit32_s * adv_mom_5            &
+                                 +              ibit31_s * adv_mom_3            &
+                                    ) *                                      &
+                                     ( w(k,j+1,i) - w(k,j-2,i) )             &
+                             +      (           ibit32_s * adv_mom_5            &
+                                    ) *                                      &
+                                     ( w(k,j+2,i) - w(k,j-3,i) )             &
+                                                        )
+#else
+                flux_s = swap_flux_y_local_w(k)
+                diss_s = swap_diss_y_local_w(k)
+#endif
+
 !
 !--             k index has to be modified near bottom and top, else array
@@ -5114,6 +5874,6 @@
                 k_mm  = k - 2 * ibit35
 
-                w_comp    = w(k+1,j,i) + w(k,j,i)
-                flux_t(k) = w_comp * rho_air(k+1) * (                        &
+                w_comp = w(k+1,j,i) + w(k,j,i)
+                flux_t = w_comp * rho_air(k+1) * (                           &
                           ( 37.0_wp * ibit35 * adv_mom_5                        &
                        +     7.0_wp * ibit34 * adv_mom_3                        &
@@ -5130,5 +5890,5 @@
                                        )
 
-                diss_t(k) = - ABS( w_comp ) * rho_air(k+1) * (               &
+                diss_t = - ABS( w_comp ) * rho_air(k+1) * (                  &
                           ( 10.0_wp * ibit35 * adv_mom_5                        &
                        +     3.0_wp * ibit34 * adv_mom_3                        &
@@ -5177,27 +5937,27 @@
 
                 tend(k,j,i) = tend(k,j,i) - (                                 &
-                      ( flux_r(k) + diss_r(k)                                 &
-                    -   swap_flux_x_local_w(k,j) - swap_diss_x_local_w(k,j)   &
-                      ) * ddx                                                 &
-                    + ( flux_n(k) + diss_n(k)                                 &
-                    -   swap_flux_y_local_w(k)   - swap_diss_y_local_w(k)     &
-                      ) * ddy                                                 &
-                    + ( ( flux_t(k) + diss_t(k) )                             &
-                    -   ( flux_d    + diss_d    )                             &
-                      ) * drho_air_zw(k) * ddzu(k+1)                          &
+                      ( ( flux_r + diss_r )                                   &
+                    -   ( flux_l + diss_l ) ) * ddx                           &
+                    + ( ( flux_n + diss_n )                                   &
+                    -   ( flux_s + diss_s ) ) * ddy                           &
+                    + ( ( flux_t + diss_t )                                   &
+                    -   ( flux_d + diss_d ) ) * drho_air_zw(k) * ddzu(k+1)    &
                                             )  + div * w(k,j,i)
 
-                swap_flux_x_local_w(k,j) = flux_r(k)
-                swap_diss_x_local_w(k,j) = diss_r(k)
-                swap_flux_y_local_w(k)   = flux_n(k)
-                swap_diss_y_local_w(k)   = diss_n(k)
-                flux_d                   = flux_t(k)
-                diss_d                   = diss_t(k)
-
+#ifndef _OPENACC
+                swap_flux_x_local_w(k,j) = flux_r
+                swap_diss_x_local_w(k,j) = diss_r
+                swap_flux_y_local_w(k)   = flux_n
+                swap_diss_y_local_w(k)   = diss_n
+#endif
+                flux_d                   = flux_t
+                diss_d                   = diss_t
+
+                !$ACC ATOMIC
                 sums_ws2_ws_l(k,tn)  = sums_ws2_ws_l(k,tn)                    &
-                      + ( flux_t(k)                                           &
+                      + ( flux_t                                              &
                        * ( w_comp - 2.0_wp * hom(k,1,3,0)                   ) &
                        / ( w_comp + SIGN( 1.0E-20_wp, w_comp )              ) &
-                        + diss_t(k)                                           &
+                        + diss_t                                              &
                        *   ABS( w_comp - 2.0_wp * hom(k,1,3,0)              ) &
                        / ( ABS( w_comp ) + 1.0E-20_wp                       ) &
@@ -5208,25 +5968,60 @@
              DO  k = nzb_max+1, nzt
 
-                u_comp    = u(k+1,j,i+1) + u(k,j,i+1) - gu
-                flux_r(k) = u_comp * (                                      &
+                u_comp = u(k+1,j,i+1) + u(k,j,i+1) - gu
+                flux_r = u_comp * (                                         &
                       37.0_wp * ( w(k,j,i+1) + w(k,j,i)   )                    &
                     -  8.0_wp * ( w(k,j,i+2) + w(k,j,i-1) )                    &
                     +           ( w(k,j,i+3) + w(k,j,i-2) ) ) * adv_mom_5
 
-                diss_r(k) = - ABS( u_comp ) * (                             &
+                diss_r = - ABS( u_comp ) * (                                &
                       10.0_wp * ( w(k,j,i+1) - w(k,j,i)   )                    &
                     -  5.0_wp * ( w(k,j,i+2) - w(k,j,i-1) )                    &
                     +           ( w(k,j,i+3) - w(k,j,i-2) ) ) * adv_mom_5
 
-                v_comp    = v(k+1,j+1,i) + v(k,j+1,i) - gv
-                flux_n(k) = v_comp * (                                      &
+#ifdef _OPENACC
+!
+!--             Recompute the left fluxes.
+                u_comp_l = u(k+1,j,i) + u(k,j,i) - gu
+                flux_l   = u_comp_l * (                                     &
+                            37.0_wp * ( w(k,j,i) + w(k,j,i-1)   )              &
+                          -  8.0_wp * ( w(k,j,i+1) + w(k,j,i-2) )              &
+                          +           ( w(k,j,i+2) + w(k,j,i-3) ) ) * adv_mom_5
+                diss_l   = - ABS( u_comp_l ) * (                            &
+                            10.0_wp * ( w(k,j,i) - w(k,j,i-1)   )              &
+                          -  5.0_wp * ( w(k,j,i+1) - w(k,j,i-2) )              &
+                          +           ( w(k,j,i+2) - w(k,j,i-3) ) ) * adv_mom_5
+#else
+                flux_l = swap_flux_x_local_w(k,j)
+                diss_l = swap_diss_x_local_w(k,j)
+#endif
+
+                v_comp = v(k+1,j+1,i) + v(k,j+1,i) - gv
+                flux_n = v_comp * (                                         &
                       37.0_wp * ( w(k,j+1,i) + w(k,j,i)   )                    &
                     -  8.0_wp * ( w(k,j+2,i) + w(k,j-1,i) )                    &
                     +           ( w(k,j+3,i) + w(k,j-2,i) ) ) * adv_mom_5
 
-                diss_n(k) = - ABS( v_comp ) * (                             &
+                diss_n = - ABS( v_comp ) * (                                &
                       10.0_wp * ( w(k,j+1,i) - w(k,j,i)   )                    &
                     -  5.0_wp * ( w(k,j+2,i) - w(k,j-1,i) )                    &
                     +           ( w(k,j+3,i) - w(k,j-2,i) ) ) * adv_mom_5
+
+#ifdef _OPENACC
+!
+!--             Recompute the south fluxes.
+                v_comp_s = v(k+1,j,i) + v(k,j,i) - gv
+                flux_s   = v_comp_s * (                                     &
+                           37.0_wp * ( w(k,j,i) + w(k,j-1,i)   )               &
+                         -  8.0_wp * ( w(k,j+1,i) +w(k,j-2,i)  )               &
+                         +           ( w(k,j+2,i) + w(k,j-3,i) ) ) * adv_mom_5
+                diss_s   = - ABS( v_comp_s ) * (                            &
+                           10.0_wp * ( w(k,j,i) - w(k,j-1,i)   )               &
+                         -  5.0_wp * ( w(k,j+1,i) - w(k,j-2,i) )               &
+                         +           ( w(k,j+2,i) - w(k,j-3,i) ) ) * adv_mom_5
+#else
+                flux_s = swap_flux_y_local_w(k)
+                diss_s = swap_diss_y_local_w(k)
+#endif
+
 !
 !--             k index has to be modified near bottom and top, else array
@@ -5240,6 +6035,6 @@
                 k_mm  = k - 2 * ibit35
 
-                w_comp    = w(k+1,j,i) + w(k,j,i)
-                flux_t(k) = w_comp * rho_air(k+1) * (                        &
+                w_comp = w(k+1,j,i) + w(k,j,i)
+                flux_t = w_comp * rho_air(k+1) * (                           &
                           ( 37.0_wp * ibit35 * adv_mom_5                        &
                        +     7.0_wp * ibit34 * adv_mom_3                        &
@@ -5256,5 +6051,5 @@
                                        )
 
-                diss_t(k) = - ABS( w_comp ) * rho_air(k+1) * (               &
+                diss_t = - ABS( w_comp ) * rho_air(k+1) * (                  &
                           ( 10.0_wp * ibit35 * adv_mom_5                        &
                        +     3.0_wp * ibit34 * adv_mom_3                        &
